**@rickosborne/foundation v2024.12.29**

***

# @rickosborne/foundation

Basic data structures and algorithms.

## Classes

### ArrayBinaryMinHeap\<T\>

#### Type Parameters

• **T**

#### Implements

- [`Queue`](README.md#queuet)\<`T`\>

#### Constructors

##### new ArrayBinaryMinHeap()

```ts
new ArrayBinaryMinHeap<T>(comparator): ArrayBinaryMinHeap<T>
```

###### Parameters

###### comparator

`Comparator`\<`T`\>

###### Returns

[`ArrayBinaryMinHeap`](README.md#arraybinaryminheapt)\<`T`\>

#### Accessors

##### length

###### Get Signature

```ts
get length(): number
```

###### Returns

`number`

###### Implementation of

`Queue.length`

##### unsorted

###### Get Signature

```ts
get unsorted(): T[]
```

###### Returns

`T`[]

#### Methods

##### add()

```ts
add(value): void
```

###### Parameters

###### value

`T`

###### Returns

`void`

###### Implementation of

`Queue.add`

##### addAll()

```ts
addAll(values): void
```

###### Parameters

###### values

`Iterable`\<`T`, `any`, `any`\>

###### Returns

`void`

##### down()

```ts
protected down(index): void
```

###### Parameters

###### index

`number`

###### Returns

`void`

##### minChild()

```ts
protected minChild(index): number
```

###### Parameters

###### index

`number`

###### Returns

`number`

##### peek()

```ts
peek(): undefined | T
```

###### Returns

`undefined` \| `T`

###### Implementation of

`Queue.peek`

##### remove()

```ts
remove(item): void
```

###### Parameters

###### item

`T`

###### Returns

`void`

###### Implementation of

`Queue.remove`

##### sort()

```ts
sort(): void
```

###### Returns

`void`

##### take()

```ts
take(): undefined | T
```

###### Returns

`undefined` \| `T`

###### Implementation of

`Queue.take`

##### toArray()

```ts
toArray(): T[]
```

###### Returns

`T`[]

###### Implementation of

`Queue.toArray`

##### up()

```ts
protected up(index): void
```

###### Parameters

###### index

`number`

###### Returns

`void`

##### values()

```ts
values(): Generator<T, void, undefined>
```

###### Returns

`Generator`\<`T`, `void`, `undefined`\>

###### Implementation of

`Queue.values`

##### valuesAndIndexes()

```ts
protected valuesAndIndexes(): Generator<[T, number], void, undefined>
```

###### Returns

`Generator`\<[`T`, `number`], `void`, `undefined`\>

***

### PriorityArray\<T\>

#### Type Parameters

• **T**

#### Implements

- [`Queue`](README.md#queuet)\<`T`\>

#### Constructors

##### new PriorityArray()

```ts
new PriorityArray<T>(comparator): PriorityArray<T>
```

###### Parameters

###### comparator

`Comparator`\<`T`\>

###### Returns

[`PriorityArray`](README.md#priorityarrayt)\<`T`\>

#### Accessors

##### \[toStringTag\]

###### Get Signature

```ts
get toStringTag: string
```

###### Returns

`string`

##### length

###### Get Signature

```ts
get length(): number
```

###### Returns

`number`

###### Implementation of

`Queue.length`

#### Methods

##### add()

```ts
add(value): void
```

###### Parameters

###### value

`T`

###### Returns

`void`

###### Implementation of

`Queue.add`

##### peek()

```ts
peek(): undefined | T
```

###### Returns

`undefined` \| `T`

###### Implementation of

`Queue.peek`

##### remove()

```ts
remove(item): void
```

###### Parameters

###### item

`T`

###### Returns

`void`

###### Implementation of

`Queue.remove`

##### take()

```ts
take(): undefined | T
```

###### Returns

`undefined` \| `T`

###### Implementation of

`Queue.take`

##### toArray()

```ts
toArray(): T[]
```

###### Returns

`T`[]

###### Implementation of

`Queue.toArray`

##### values()

```ts
values(): Generator<T, void, undefined>
```

###### Returns

`Generator`\<`T`, `void`, `undefined`\>

###### Implementation of

`Queue.values`

***

### PriorityLinkedList\<T\>

#### Type Parameters

• **T**

#### Implements

- [`Queue`](README.md#queuet)\<`T`\>

#### Constructors

##### new PriorityLinkedList()

```ts
new PriorityLinkedList<T>(comparator): PriorityLinkedList<T>
```

###### Parameters

###### comparator

`Comparator`\<`T`\>

###### Returns

[`PriorityLinkedList`](README.md#prioritylinkedlistt)\<`T`\>

#### Accessors

##### length

###### Get Signature

```ts
get length(): number
```

###### Returns

`number`

###### Implementation of

`Queue.length`

#### Methods

##### add()

```ts
add(item): void
```

###### Parameters

###### item

`T`

###### Returns

`void`

###### Implementation of

`Queue.add`

##### peek()

```ts
peek(): undefined | T
```

###### Returns

`undefined` \| `T`

###### Implementation of

`Queue.peek`

##### remove()

```ts
remove(item): void
```

###### Parameters

###### item

`T`

###### Returns

`void`

###### Implementation of

`Queue.remove`

##### take()

```ts
take(): undefined | T
```

###### Returns

`undefined` \| `T`

###### Implementation of

`Queue.take`

##### toArray()

```ts
toArray(): T[]
```

###### Returns

`T`[]

###### Implementation of

`Queue.toArray`

##### values()

```ts
values(): Generator<T, void, undefined>
```

###### Returns

`Generator`\<`T`, `void`, `undefined`\>

###### Implementation of

`Queue.values`

***

### SkipList\<T\>

#### Type Parameters

• **T**

#### Implements

- [`Queue`](README.md#queuet)\<`T`\>

#### Constructors

##### new SkipList()

```ts
new SkipList<T>(
   comparator, 
   maxLevel, 
random): SkipList<T>
```

###### Parameters

###### comparator

`Comparator`\<`T`\>

###### maxLevel

`number` = `8`

###### random

() => `number`

###### Returns

[`SkipList`](README.md#skiplistt)\<`T`\>

#### Properties

##### comparator

```ts
protected readonly comparator: Comparator<T>;
```

##### maxLevel

```ts
protected readonly maxLevel: number = 8;
```

##### random()

```ts
protected readonly random: () => number;
```

###### Returns

`number`

#### Accessors

##### length

###### Get Signature

```ts
get length(): number
```

###### Returns

`number`

###### Implementation of

`Queue.length`

#### Methods

##### add()

```ts
add(value): void
```

###### Parameters

###### value

`T`

###### Returns

`void`

###### Implementation of

`Queue.add`

##### buildNode()

```ts
protected buildNode(value, level): SkipNode<T>
```

###### Parameters

###### value

`T`

###### level

`number`

###### Returns

`SkipNode`\<`T`\>

##### peek()

```ts
peek(): undefined | T
```

###### Returns

`undefined` \| `T`

###### Implementation of

`Queue.peek`

##### randomLevel()

```ts
protected randomLevel(): number
```

###### Returns

`number`

##### remove()

```ts
remove(value): void
```

###### Parameters

###### value

`T`

###### Returns

`void`

###### Implementation of

`Queue.remove`

##### take()

```ts
take(): undefined | T
```

###### Returns

`undefined` \| `T`

###### Implementation of

`Queue.take`

##### toArray()

```ts
toArray(): T[]
```

###### Returns

`T`[]

###### Implementation of

`Queue.toArray`

##### values()

```ts
values(): Generator<T, void, undefined>
```

###### Returns

`Generator`\<`T`, `void`, `undefined`\>

###### Implementation of

`Queue.values`

##### valuesAndIndexes()

```ts
valuesAndIndexes(): Generator<[T, number], void, undefined>
```

###### Returns

`Generator`\<[`T`, `number`], `void`, `undefined`\>

## Type Aliases

### BinaryIndexOfConfig

```ts
type BinaryIndexOfConfig = object;
```

#### Type declaration

##### firstNonUnique?

```ts
optional firstNonUnique: boolean;
```

The values may not be unique, and the result should be the
index of the first occurrence.
When a value is found, step back and compare until the first
occurrence of that value is found.  Will always cause extra
comparisons.

###### Default

```ts
{false}
```

##### initialLeft?

```ts
optional initialLeft: number;
```

Left-most index to check.  Inclusive.

###### Default

```ts
{0}
```

##### initialRight?

```ts
optional initialRight: number;
```

Right-most index, considered out-of-bounds.  Exclusive.

###### Default

```ts
The length of the array.
```

##### rangeCheck?

```ts
optional rangeCheck: boolean;
```

Perform an initial check against the first and last elements.
Can speed up searches where you expect the value to be less
than or greater than all the elements, such as when you mostly
insert at the front or append to the back.
But it can just add extra comparisons for small arrays, or
arrays where most values will be in the middle.

###### Default

```ts
{false}
```

***

### ChainableComparator\<T\>

```ts
type ChainableComparator<T> = Comparator<T> & object;
```

#### Type declaration

##### desc

###### Get Signature

```ts
get desc(): ChainableComparator<T>
```

###### Returns

[`ChainableComparator`](README.md#chainablecomparatort)\<`T`\>

##### nullsFirst

###### Get Signature

```ts
get nullsFirst(): ChainableComparator<undefined | null | T>
```

###### Returns

[`ChainableComparator`](README.md#chainablecomparatort)\<`undefined` \| `null` \| `T`\>

##### nullsLast

###### Get Signature

```ts
get nullsLast(): ChainableComparator<undefined | null | T>
```

###### Returns

[`ChainableComparator`](README.md#chainablecomparatort)\<`undefined` \| `null` \| `T`\>

#### Type Parameters

• **T**

***

### ComparatorBuilder\<T\>

```ts
type ComparatorBuilder<T> = object;
```

#### Type Parameters

• **T**

#### Type declaration

##### desc

###### Get Signature

```ts
get desc(): ComparatorBuilder<T>
```

###### Returns

[`ComparatorBuilder`](README.md#comparatorbuildert)\<`T`\>

##### nullsFirst

###### Get Signature

```ts
get nullsFirst(): ComparatorBuilder<T>
```

###### Returns

[`ComparatorBuilder`](README.md#comparatorbuildert)\<`T`\>

##### nullsLast

###### Get Signature

```ts
get nullsLast(): ComparatorBuilder<T>
```

###### Returns

[`ComparatorBuilder`](README.md#comparatorbuildert)\<`T`\>

##### build()

###### Returns

`Comparator`\<`T`\>

##### num()

###### Parameters

###### accessor

(`t`) => `undefined` \| `number`

###### Returns

[`ComparatorBuilder`](README.md#comparatorbuildert)\<`T`\>

##### str()

###### Parameters

###### accessor

(`t`) => `undefined` \| `string`

###### Returns

[`ComparatorBuilder`](README.md#comparatorbuildert)\<`T`\>

***

### DoubleLinkedList\<T\>

```ts
type DoubleLinkedList<T> = List<T> & object;
```

#### Type declaration

##### tail

###### Get Signature

```ts
get tail(): undefined | T
```

###### Returns

`undefined` \| `T`

##### reverseValues()

###### Returns

`Generator`\<`T`, `void`, `undefined`\>

##### reverseValuesAndIndexes()

###### Returns

`Generator`\<[`T`, `number`], `void`, `undefined`\>

##### reverseWalk()

###### Parameters

###### block

(`value`, `index`) => [`ListWalkDecision`](README.md#listwalkdecisiont)\<`T`\>

###### Returns

`void`

#### Type Parameters

• **T**

***

### GetPropertyDescriptor\<T\>

```ts
type GetPropertyDescriptor<T> = PropertyDescriptorFlags & object;
```

Partial property descriptor which includes only an accessor (getter)
and not a mutator, and is thus read-only.

#### Type declaration

##### set?

```ts
optional set: undefined;
```

##### get()

###### Returns

`T`

#### Type Parameters

• **T**

***

### GetSetPropertyDescriptor\<T\>

```ts
type GetSetPropertyDescriptor<T> = PropertyDescriptorFlags & object;
```

Partial property descriptor which includes both an accessor (getter)
and mutator (setter), and is thus read-write.

#### Type declaration

##### get()

###### Returns

`T`

##### set()

###### Parameters

###### t

`T`

###### Returns

`void`

#### Type Parameters

• **T**

***

### IfReadOnlyDescriptor\<T, D\>

```ts
type IfReadOnlyDescriptor<T, D> = D extends 
  | ReadOnlyPropertyDescriptor
  | GetPropertyDescriptor<unknown> ? T : never;
```

Filter type <kbd>T</kbd> based on whether the property descriptor
<kbd>D</kbd> would produce a read-only property.

#### Type Parameters

• **T**

• **D** *extends* [`TypedPropertyDescriptor`](README.md#typedpropertydescriptort)\<`unknown`\>

***

### IfReadWriteDescriptor\<T, D\>

```ts
type IfReadWriteDescriptor<T, D> = D extends 
  | ReadOnlyPropertyDescriptor
  | GetPropertyDescriptor<unknown> ? never : T;
```

Filter type <kbd>T</kbd> based on whether the property descriptor
<kbd>D</kbd> would produce a read-write (or write-only) property.

#### Type Parameters

• **T**

• **D** *extends* [`TypedPropertyDescriptor`](README.md#typedpropertydescriptort)\<`unknown`\>

***

### IfWriteOnlyDescriptor\<T, D\>

```ts
type IfWriteOnlyDescriptor<T, D> = D extends SetPropertyDescriptor<unknown> ? T : never;
```

Filter type <kbd>T</kbd> based on whether the property descriptor
<kbd>D</kbd> would produce a write-only property.
Note:
JS has a concept of a write-only property, and the unit tests cover this.
However, TS doesn't have a way of expressing it, at least as of v5.8.
So for now, it goes into the read-write bucket, even though you can't
actually read from it.
The alternative would be to set it to `undefined`, to show you can't
read from it ... but then you lose the type info for the setter.  Yuck.
For now ...
The types below will, ahem, mangle the types they produce.  Just a little.
If you produce a setter-only property, it will end up looking like:
```typescript
const withSetterOnly: WithSetterOnly = addProperty({}, "whatever", { set: (value: string) => void(whatever(value)) });
type WithSetterOnly = {
   whatever: string;
   whateverIsWriteOnly?: undefined;
}
```
So you get a reminder without breaking anything too hard.

#### Type Parameters

• **T**

• **D** *extends* [`TypedPropertyDescriptor`](README.md#typedpropertydescriptort)\<`unknown`\>

***

### IntGenerator

```ts
type IntGenerator = Generator<number, void, undefined> & object;
```

Mixin for a generator which also has the ability to bundle
its output into an array.

#### Type declaration

##### toArray()

###### Returns

`number`[]

***

### IntGeneratorTo

```ts
type IntGeneratorTo = object;
```

Partial for the last step of an [IntRange](README.md#intrange) builder.

#### Type declaration

##### toExclusive()

End before this number.

###### Parameters

###### stopExclusive

`number`

###### Returns

[`IntGenerator`](README.md#intgenerator)

##### toInclusive()

End after this number.

###### Parameters

###### stopInclusive

`number`

###### Returns

[`IntGenerator`](README.md#intgenerator)

***

### IntRange

```ts
type IntRange = object;
```

Integer range generators which (hopefully) make it super clear what
your boundary, direction, and increment are.

#### Type declaration

##### from()

Start with the given number, inclusively.

###### Parameters

###### startInclusive

`number`

###### Returns

`object`

###### down

###### Get Signature

```ts
get down(): IntGeneratorTo
```

Decrement by 1.

###### Returns

[`IntGeneratorTo`](README.md#intgeneratorto)

###### up

###### Get Signature

```ts
get up(): IntGeneratorTo
```

Increment by 1.

###### Returns

[`IntGeneratorTo`](README.md#intgeneratorto)

###### by()

Increment/decrement by this number.

###### Parameters

###### skip

`number`

###### Returns

[`IntGeneratorTo`](README.md#intgeneratorto)

***

### List\<T\>

```ts
type List<T> = object;
```

#### Type Parameters

• **T**

#### Type declaration

##### \[toStringTag\]

```ts
readonly [toStringTag]: string;
```

##### head

###### Get Signature

```ts
get head(): undefined | T
```

###### Returns

`undefined` \| `T`

##### isEmpty

###### Get Signature

```ts
get isEmpty(): boolean
```

###### Returns

`boolean`

##### length

###### Get Signature

```ts
get length(): number
```

###### Returns

`number`

##### at()

###### Parameters

###### index

`number`

###### Returns

`undefined` \| `T`

##### insertAt()

###### Parameters

###### index

`number`

###### value

`T`

###### Returns

`void`

##### pop()

###### Returns

`undefined` \| `T`

##### push()

###### Parameters

###### value

`T`

###### Returns

`void`

##### shift()

###### Returns

`undefined` \| `T`

##### toArray()

###### Returns

`T`[]

##### unshift()

###### Parameters

###### value

`T`

###### Returns

`void`

##### values()

###### Returns

`Generator`\<`T`, `void`, `undefined`\>

##### valuesAndIndexes()

###### Returns

`Generator`\<[`T`, `number`], `void`, `undefined`\>

##### walk()

###### Parameters

###### block

(`value`, `index`) => [`ListWalkDecision`](README.md#listwalkdecisiont)\<`T`\>

###### Returns

`void`

***

### ListWalkDecision\<T\>

```ts
type ListWalkDecision<T> = object;
```

#### Type Parameters

• **T**

#### Type declaration

##### deleteItem?

```ts
optional deleteItem: boolean;
```

##### insertAfter?

```ts
optional insertAfter: T;
```

##### insertBefore?

```ts
optional insertBefore: T;
```

##### keepWalking

```ts
keepWalking: boolean;
```

***

### PropertiesFromDescriptors\<R\>

```ts
type PropertiesFromDescriptors<R> = { readonly [K in ReadOnlyDescriptorsKeys<R>]: R[K] extends TypedPropertyDescriptor<infer V> ? V : never } & { [K in ReadWriteDescriptorsKeys<R>]: R[K] extends TypedPropertyDescriptor<infer V> ? V : never } & { [K in RenamedWriteOnlyDescriptorsKeys<R>]?: undefined };
```

Produce an object with the properties described by the descriptors.
See [RenameIfWriteOnlyDescriptor](README.md#renameifwriteonlydescriptorkey-d) for details on the mangling
of write-only properties.

#### Type Parameters

• **R** *extends* `Record`\<`string`, [`TypedPropertyDescriptor`](README.md#typedpropertydescriptort)\<`unknown`\>\>

***

### PropertyDescriptorFlags

```ts
type PropertyDescriptorFlags = object;
```

Basic flags for any property descriptor.

#### Type declaration

##### configurable?

```ts
optional configurable: boolean;
```

##### enumerable?

```ts
optional enumerable: boolean;
```

##### writable?

```ts
optional writable: boolean;
```

***

### PropertyFromDescriptor\<K, D\>

```ts
type PropertyFromDescriptor<K, D> = D extends TypedPropertyDescriptor<infer V> ? { readonly [key in IfReadOnlyDescriptor<K, D>]: V } & { [key in IfReadWriteDescriptor<K, D>]: V } & { [key in RenameIfWriteOnlyDescriptor<K, D>]?: undefined } : never;
```

Produce a single-property object type for the given property
descriptor.  Note: will produce an additional mangled pseudo-property
for write-only properties.
See [RenameIfWriteOnlyDescriptor](README.md#renameifwriteonlydescriptorkey-d) for details on the mangling.

#### Type Parameters

• **K** *extends* `string`

• **D** *extends* [`TypedPropertyDescriptor`](README.md#typedpropertydescriptort)\<`unknown`\>

***

### Queue\<T\>

```ts
type Queue<T> = object;
```

#### Type Parameters

• **T**

#### Type declaration

##### length

###### Get Signature

```ts
get length(): number
```

###### Returns

`number`

##### add()

###### Parameters

###### value

`T`

###### Returns

`void`

##### peek()

###### Returns

`undefined` \| `T`

##### remove()

###### Parameters

###### value

`T`

###### Returns

`void`

##### take()

###### Returns

`undefined` \| `T`

##### toArray()

###### Returns

`T`[]

##### values()

###### Returns

`Generator`\<`T`, `void`, `undefined`\>

***

### ReadOnlyDescriptorsKeys\<R\>

```ts
type ReadOnlyDescriptorsKeys<R> = R extends Record<infer K, TypedPropertyDescriptor<unknown>> ? { [key in K]: IfReadOnlyDescriptor<key, R[key]> }[K] : never;
```

Produce the keys for the given property descriptors record which
would produce read-only properties.

#### Type Parameters

• **R**

***

### ReadOnlyPropertyDescriptor

```ts
type ReadOnlyPropertyDescriptor = object;
```

Partial property descriptor which has been
marked as non-writable.

#### Type declaration

##### writable

```ts
writable: false;
```

***

### ReadWriteDescriptorsKeys\<R\>

```ts
type ReadWriteDescriptorsKeys<R> = R extends Record<infer K, TypedPropertyDescriptor<unknown>> ? { [key in K]: IfReadWriteDescriptor<key, R[key]> }[K] : never;
```

Produce the keys for the given property descriptors record which
would produce read-write (or write-only) properties.

#### Type Parameters

• **R**

***

### RenamedWriteOnlyDescriptorsKeys\<R\>

```ts
type RenamedWriteOnlyDescriptorsKeys<R> = R extends Record<infer K, TypedPropertyDescriptor<unknown>> ? { [key in string & K]: RenameIfWriteOnlyDescriptor<key, R[key]> }[string & K] : never;
```

Produce the <strong>mangled</strong> keys for the given property
descriptors record which would produce write-only properties.
See [RenameIfWriteOnlyDescriptor](README.md#renameifwriteonlydescriptorkey-d) for details on the mangling.

#### Type Parameters

• **R**

***

### RenameIfWriteOnlyDescriptor\<Key, D\>

```ts
type RenameIfWriteOnlyDescriptor<Key, D> = D extends SetPropertyDescriptor<unknown> ? `${Key}IsWriteOnly` : never;
```

Mangle the given <kbd>Key</kbd> to <kbd>${Key}IsWriteOnly</kbd> if
property descriptor <kbd>D</kbd> would produce a write-only property.

#### Type Parameters

• **Key** *extends* `string`

• **D** *extends* [`TypedPropertyDescriptor`](README.md#typedpropertydescriptort)\<`unknown`\>

***

### SearchResult

```ts
type SearchResult = 
  | {
  before: undefined;
  comparisons: number;
  exists: true;
  index: number;
 }
  | {
  before: number;
  comparisons: number;
  exists: false;
  index: undefined;
};
```

***

### SetPropertyDescriptor\<T\>

```ts
type SetPropertyDescriptor<T> = PropertyDescriptorFlags & object;
```

Partial property descriptor which includes only a mutator (setter)
and not an accessor (getter), and is thus write-only.
Note: TypeScript support for these kinds of properties is very
poor as of v5.7.

#### Type declaration

##### get?

```ts
optional get: undefined;
```

##### set()

###### Parameters

###### t

`T`

###### Returns

`void`

#### Type Parameters

• **T**

***

### ShuffleConfig\<T\>

```ts
type ShuffleConfig<T> = object;
```

#### Type Parameters

• **T**

#### Type declaration

##### into?

```ts
optional into: T[];
```

Target array.  Defaults to the given array, shuffling in place.

##### random01()?

```ts
optional random01: () => number;
```

Generate a random float in the range <kbd>[0..1)</kbd>.

###### Returns

`number`

***

### TypedPropertyDescriptor\<T\>

```ts
type TypedPropertyDescriptor<T> = 
  | ValuePropertyDescriptor<T>
  | GetPropertyDescriptor<T>
  | SetPropertyDescriptor<T>
| GetSetPropertyDescriptor<T>;
```

Union for reasonable configurations of property descriptors which
could affect the type for the property.

#### Type Parameters

• **T**

***

### ValuePropertyDescriptor\<T\>

```ts
type ValuePropertyDescriptor<T> = PropertyDescriptorFlags & object;
```

Partial property descriptor which contains a static value,
instead of an accessor and/or mutator.

#### Type declaration

##### value

```ts
value: T;
```

#### Type Parameters

• **T**

## Variables

### intRange

```ts
const intRange: IntRange;
```

## Functions

### addProperties()

```ts
function addProperties<T, K, R>(target, descriptors): { [k in string | number | symbol]: (T & { readonly [K in string | number | symbol]: R[K] extends TypedPropertyDescriptor<V> ? V : never } & { [K in string | number | symbol]: R[K] extends TypedPropertyDescriptor<V> ? V : never } & { [K in `${string}IsWriteOnly`]?: undefined })[k] }
```

A more type-friendly version of <kbd>Object.defineProperties</kbd>.

#### Type Parameters

• **T**

• **K** *extends* `string`

• **R** *extends* `Record`\<`K`, [`TypedPropertyDescriptor`](README.md#typedpropertydescriptort)\<`unknown`\>\>

#### Parameters

##### target

`T`

##### descriptors

`R`

#### Returns

\{ \[k in string \| number \| symbol\]: (T & \{ readonly \[K in string \| number \| symbol\]: R\[K\] extends TypedPropertyDescriptor\<V\> ? V : never \} & \{ \[K in string \| number \| symbol\]: R\[K\] extends TypedPropertyDescriptor\<V\> ? V : never \} & \{ \[K in \`$\{string\}IsWriteOnly\`\]?: undefined \})\[k\] \}

#### See

[Object.defineProperties on MDN](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperties)

***

### addProperty()

```ts
function addProperty<T, K, V, D>(
   target, 
   key, 
descriptor): { [k in string | number | symbol]: (T & PropertyFromDescriptor<K, D>)[k] }
```

A more type-friendly version of <kbd>Object.defineProperty</kbd>.

#### Type Parameters

• **T**

• **K** *extends* `string`

• **V**

• **D** *extends* [`TypedPropertyDescriptor`](README.md#typedpropertydescriptort)\<`V`\>

#### Parameters

##### target

`T`

##### key

`K`

##### descriptor

`D`

#### Returns

\{ \[k in string \| number \| symbol\]: (T & PropertyFromDescriptor\<K, D\>)\[k\] \}

#### See

[Object.defineProperty on MDN](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperty)

***

### arrayBinaryMaxHeap()

```ts
function arrayBinaryMaxHeap<T>(comparator): ArrayBinaryMinHeap<T>
```

#### Type Parameters

• **T**

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`ArrayBinaryMinHeap`](README.md#arraybinaryminheapt)\<`T`\>

***

### arrayBinaryMinHeap()

```ts
function arrayBinaryMinHeap<T>(comparator): ArrayBinaryMinHeap<T>
```

#### Type Parameters

• **T**

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`ArrayBinaryMinHeap`](README.md#arraybinaryminheapt)\<`T`\>

***

### binaryIndexOf()

```ts
function binaryIndexOf<T>(
   value, 
   items, 
   comparator, 
   __namedParameters): SearchResult
```

#### Type Parameters

• **T**

#### Parameters

##### value

`T`

##### items

`T`[]

##### comparator

`Comparator`\<`T`\>

##### \_\_namedParameters

[`BinaryIndexOfConfig`](README.md#binaryindexofconfig) = `{}`

#### Returns

[`SearchResult`](README.md#searchresult)

***

### chainableComparator()

```ts
function chainableComparator<T>(comparator): ChainableComparator<T>
```

#### Type Parameters

• **T**

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`ChainableComparator`](README.md#chainablecomparatort)\<`T`\>

***

### comparatorBuilder()

```ts
function comparatorBuilder<T>(): ComparatorBuilder<T>
```

#### Type Parameters

• **T**

#### Returns

[`ComparatorBuilder`](README.md#comparatorbuildert)\<`T`\>

***

### deepSort()

```ts
function deepSort<T>(obj): T
```

Sort an object, and any objects nested through plain objects
or arrays, by key, so when JSON stringified you will get a
deterministic output.

#### Type Parameters

• **T**

#### Parameters

##### obj

`T`

#### Returns

`T`

***

### doubleLinkedList()

```ts
function doubleLinkedList<T>(): DoubleLinkedList<T>
```

#### Type Parameters

• **T**

#### Returns

[`DoubleLinkedList`](README.md#doublelinkedlistt)\<`T`\>

***

### numberAsc()

```ts
function numberAsc(a, b): number
```

#### Parameters

##### a

`number`

##### b

`number`

#### Returns

`number`

***

### priorityArray()

```ts
function priorityArray<T>(comparator): Queue<T>
```

#### Type Parameters

• **T**

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`Queue`](README.md#queuet)\<`T`\>

***

### priorityLinkedList()

```ts
function priorityLinkedList<T>(comparator): Queue<T>
```

#### Type Parameters

• **T**

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`Queue`](README.md#queuet)\<`T`\>

***

### shuffle()

```ts
function shuffle<T>(list, __namedParameters): T[]
```

Fisher-Yates shuffle.
Defaults to in-place sorting, but can sort into a new one via <kbd>into</kbd>.

#### Type Parameters

• **T**

#### Parameters

##### list

`T`[]

##### \_\_namedParameters

[`ShuffleConfig`](README.md#shuffleconfigt)\<`T`\> = `{}`

#### Returns

`T`[]

#### See

[Fisher-Yates shuffle on Wikipedia](https://en.wikipedia.org/wiki/Fisher%E2%80%93Yates_shuffle)

***

### singleLinkedList()

```ts
function singleLinkedList<T>(): List<T>
```

#### Type Parameters

• **T**

#### Returns

[`List`](README.md#listt)\<`T`\>

***

### skipList()

```ts
function skipList<T>(comparator): SkipList<T>
```

#### Type Parameters

• **T**

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

[`SkipList`](README.md#skiplistt)\<`T`\>

***

### toShuffled()

```ts
function toShuffled<T>(list, config?): T[]
```

#### Type Parameters

• **T**

#### Parameters

##### list

`T`[]

##### config?

`Omit`\<[`ShuffleConfig`](README.md#shuffleconfigt)\<`T`\>, `"into"`\>

#### Returns

`T`[]

***

### withNullsFirst()

```ts
function withNullsFirst<T>(comparator): Comparator<undefined | null | T>
```

#### Type Parameters

• **T**

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

`Comparator`\<`undefined` \| `null` \| `T`\>

***

### withNullsLast()

```ts
function withNullsLast<T>(comparator): Comparator<undefined | null | T>
```

#### Type Parameters

• **T**

#### Parameters

##### comparator

`Comparator`\<`T`\>

#### Returns

`Comparator`\<`undefined` \| `null` \| `T`\>
